/*********************************************************************
//  created:    2007/07/28 - 11:51
//  filename:   DbtPlyVtgManager.h
//
//  author:     Gerald Dherbomez 
//              Copyright Heudiasyc UMR UTC/CNRS 6599
// 
//  version:    $Id: $
//
//  purpose:    Dbite Player GST Manager
*********************************************************************/

#ifndef DBTPLYVTGMANAGER_H
#define DBTPLYVTGMANAGER_H

#include <QLCDNumber>
#include <QGroupBox>
#include <QLabel>
#include <QLayout>

#include "Pacpus/DbitePlayer/DbtPlyFileManager.h"
#include "../Gps/structure_gps.h"
//#include "DbitePlayer/SensorTcpServer.h" //added
#include "Pacpus/PacpusTools/ShMem.h"

#include "DbtPlyGpsConfig.h"

namespace pacpus {

class ComponentManager;

class PACPUSLIB_API DbtPlyVtgManager
        : public DbtPlyFileManager
{
public:
    DbtPlyVtgManager(QString name);
    ~DbtPlyVtgManager();
    virtual ComponentBase::COMPONENT_CONFIGURATION configureComponent(XmlComponentConfig config);
    
    virtual void addInputs();
    virtual void addOutputs();
protected:
    void processData(road_time_t t, road_timerange_t tr , void * buffer);
    virtual void startActivity();
    virtual void stopActivity();

private:
    trame_vtg * val; 
    // Local copy of Vtg data with timestamp
    TimestampedVtgFrame mVtg;

    // Declaration of outputs
    OutputInterface<TimestampedVtgFrame, DbtPlyVtgManager>* outVtg;

};

} // namespace pacpus

#endif // DBTPLYVTGMANAGER_H
